diff --git a/yum/__init__.py b/yum/__init__.py
index 99039e0..bf13f40 100644
--- a/yum/__init__.py
+++ b/yum/__init__.py
@@ -1943,116 +2397,215 @@ class YumBase(depsolve.Depsolve):
         self.history.close()
 
         self.plugins.run('predownload', pkglist=pkglist)
-        repo_cached = False
+        beenthere = set() # only once, please. BZ 468401
+        downloadonly = getattr(self.conf, 'downloadonly', False)
         remote_pkgs = []
         remote_size = 0
+
+        def verify_local(po):
+            local = po.localPkg()
+            if local in beenthere:
+                # This is definitely a depsolver bug.  Make it fatal?
+                self.verbose_logger.warn(_("ignoring a dupe of %s") % po)
+                return True
+            beenthere.add(local)
+            if downloadonly and not os.path.exists(local):
+              # Check before we munge the name...
+              po.repo._preload_pkg_from_system_cache(po)
+            if os.path.exists(local):
+                if self.verifyPkg(local, po, False):
+                    self.verbose_logger.debug(_("using local copy of %s") % po)
+                    return True
+                if po.repo.cache:
+                    adderror(po, _('package fails checksum but caching is '
+                        'enabled for %s') % po.repo.id)
+                    return False
+            if downloadonly:
+                po.localpath += '.%d.tmp' % os.getpid()
+                try: os.rename(local, po.localpath)
+                except OSError: pass
+                po.returnIdSum()
+                po.basepath # prefetch now; fails when repos are closed
+            return False
+
+        pkgs = []
         for po in pkglist:
             if hasattr(po, 'pkgtype') and po.pkgtype == 'local':
                 continue
-                    
-            local = po.localPkg()
-            if os.path.exists(local):
-                if not self.verifyPkg(local, po, False):
-                    if po.repo.cache:
-                        repo_cached = True
-                        adderror(po, _('package fails checksum but caching is '
-                            'enabled for %s') % po.repo.id)
-                else:
-                    self.verbose_logger.debug(_("using local copy of %s") %(po,))
+            if verify_local(po):
+                continue
+            if errors:
+                return errors
+            pkgs.append(po)
+
+        # download presto metadata and use drpms
+        presto = DeltaInfo(self, pkgs, adderror)
+        deltasize = rpmsize = 0
+        for po in pkgs:
+            if isinstance(po, DeltaPackage):
+                if verify_local(po):
+                    # there's .drpm already, use it
+                    presto.rebuild(po)
                     continue
-                        
+                deltasize += po.size
+                rpmsize += po.rpm.size
             remote_pkgs.append(po)
             remote_size += po.size
-            
-            # caching is enabled and the package 
-            # just failed to check out there's no 
-            # way to save this, report the error and return
-            if (self.conf.cache or repo_cached) and errors:
-                return errors
-                
+        if deltasize:
+            self.verbose_logger.info(_('Delta RPMs reduced %s of updates to %s (%d%% saved)'),
+                format_number(rpmsize), format_number(deltasize), 100 - deltasize*100.0/rpmsize)
+
+        if downloadonly:
+            if hasattr(self, '_old_cachedir'):
+              # Try to link/copy them out, if we have somewhere to put them.
+
+              for po in pkglist:
+                if not po.localpath.startswith(self.conf.cachedir):
+                  continue
+
+                end = po.localpath[len(self.conf.cachedir):]
+                try:
+                  os.link(po.localpath, self._old_cachedir + end)
+                except:
+                  try:
+                    shutil.copy2(po.localpath, self._old_cachedir + end)
+                  except:
+                    pass
+
+            # close DBs, unlock
+            self.repos.close()
+            self.closeRpmDB()
+            self.doUnlock()
 
-        remote_pkgs.sort(mediasort)
-        #  This is kind of a hack and does nothing in non-Fedora versions,
-        # we'll fix it one way or anther soon.
-        if (hasattr(urlgrabber.progress, 'text_meter_total_size') and
-            len(remote_pkgs) > 1):
-            urlgrabber.progress.text_meter_total_size(remote_size)
         beg_download = time.time()
-        i = 0
-        local_size = 0
-        done_repos = set()
-        for po in remote_pkgs:
-            #  Recheck if the file is there, works around a couple of weird
-            # edge cases.
-            local = po.localPkg()
-            i += 1
-            if os.path.exists(local):
-                if self.verifyPkg(local, po, False):
-                    self.verbose_logger.debug(_("using local copy of %s") %(po,))
-                    remote_size -= po.size
+        all_remote_pkgs = remote_pkgs
+        all_remote_size = remote_size
+        while True:
+            remote_pkgs.sort(mediasort)
+            #  This is kind of a hack and does nothing in non-Fedora versions,
+            # we'll fix it one way or anther soon.
+            if (hasattr(urlgrabber.progress, 'text_meter_total_size') and
+                len(remote_pkgs) > 1):
+                urlgrabber.progress.text_meter_total_size(remote_size)
+            i = 0
+            local_size = [0]
+            done_repos = set()
+            async = hasattr(urlgrabber.grabber, 'parallel_wait')
+            for po in remote_pkgs:
+                i += 1
+
+                def checkfunc(obj, po=po):
+                    self.verifyPkg(obj, po, 1)
+                    if po.localpath.endswith('.tmp'):
+                        rpmfile = po.localpath.rsplit('.', 2)[0]
+                        os.rename(po.localpath, rpmfile)
+                        po.localpath = rpmfile
+                    local_size[0] += po.size
                     if hasattr(urlgrabber.progress, 'text_meter_total_size'):
                         urlgrabber.progress.text_meter_total_size(remote_size,
-                                                                  local_size)
-                    continue
-                if os.path.getsize(local) >= po.size:
-                    os.unlink(local)
-
-            checkfunc = (self.verifyPkg, (po, 1), {})
-            dirstat = os.statvfs(po.repo.pkgdir)
-            if (dirstat.f_bavail * dirstat.f_bsize) <= long(po.size):
-                adderror(po, _('Insufficient space in download directory %s\n'
-                        "    * free   %s\n"
-                        "    * needed %s") %
-                         (po.repo.pkgdir,
-                          format_number(dirstat.f_bavail * dirstat.f_bsize),
-                          format_number(po.size)))
-                continue
-            
-            try:
-                if i == 1 and not local_size and remote_size == po.size:
-                    text = os.path.basename(po.relativepath)
-                else:
-                    text = '(%s/%s): %s' % (i, len(remote_pkgs),
-                                            os.path.basename(po.relativepath))
-                mylocal = po.repo.getPackage(po,
-                                   checkfunc=checkfunc,
-                                   text=text,
-                                   cache=po.repo.http_caching != 'none',
-                                   )
-                local_size += po.size
-                if hasattr(urlgrabber.progress, 'text_meter_total_size'):
-                    urlgrabber.progress.text_meter_total_size(remote_size,
-                                                              local_size)
-                if po.repoid not in done_repos:
-                    #  Check a single package per. repo. ... to give a hint to
-                    # the user on big downloads.
-                    result, errmsg = self.sigCheckPkg(po)
-                    if result != 0:
-                        self.verbose_logger.warn("%s", errmsg)
-                done_repos.add(po.repoid)
-
-            except Errors.RepoError, e:
-                adderror(po, str(e))
-            else:
-                po.localpath = mylocal
-                if po in errors:
-                    del errors[po]
-
-        if hasattr(urlgrabber.progress, 'text_meter_total_size'):
-            urlgrabber.progress.text_meter_total_size(0)
-        if callback_total is not None and not errors:
-            callback_total(remote_pkgs, remote_size, beg_download)
+                                                                  local_size[0])
+                    if isinstance(po, DeltaPackage):
+                        presto.rebuild(po)
+                        return
+                    else:
+                        presto.dequeue_max()
+
+                    if po.repoid not in done_repos:
+                        done_repos.add(po.repoid)
+                        #  Check a single package per. repo. ... to give a hint to
+                        # the user on big downloads.
+                        result, errmsg = self.sigCheckPkg(po)
+                        if result != 0:
+                            self.verbose_logger.warn("%s", errmsg)
+                    po.localpath = obj.filename
+                    if po in errors:
+                        del errors[po]
+
+                text = os.path.basename(po.relativepath)
+                kwargs = {}
+                if async and po.repo._async:
+                    kwargs['failfunc'] = lambda obj, po=po: adderror(po, exception2msg(obj.exception))
+                    kwargs['async'] = True
+                elif not (i == 1 and not local_size[0] and remote_size == po.size):
+                    text = '(%s/%s): %s' % (i, len(remote_pkgs), text)
+                try:
+                    po.repo.getPackage(po,
+                                       checkfunc=checkfunc,
+                                       text=text,
+                                       cache=po.repo.http_caching != 'none',
+                                       **kwargs
+                                       )
+                except Errors.RepoError, e:
+                    adderror(po, exception2msg(e))
+            if async:
+                try:
+                    urlgrabber.grabber.parallel_wait()
+                except KeyboardInterrupt:
+                    for po in remote_pkgs:
+                        if po.localpath.endswith('.tmp'):
+                            misc.unlink_f(po.localpath)
+                        elif isinstance(po, DeltaPackage) and po.rpm.localpath.endswith('.tmp'):
+                            misc.unlink_f(po.rpm.localpath)
+                    raise
+            presto.dequeue_all()
+            presto.wait()
+
+            if hasattr(urlgrabber.progress, 'text_meter_total_size'):
+                urlgrabber.progress.text_meter_total_size(0)
+
+            fatal = False
+            for po in errors:
+                if not isinstance(po, DeltaPackage):
+                    fatal = True
+                    break
+            if not errors or fatal:
+                break
 
-        self.plugins.run('postdownload', pkglist=pkglist, errors=errors)
+            # there were drpm related errors *only*
+            remote_pkgs = []
+            remote_size = 0
+            for po in errors:
+                po = po.rpm
+                remote_pkgs.append(po)
+                remote_size += po.size
+            # callback_total needs the total pkg count
+            all_remote_pkgs.extend(remote_pkgs)
+            all_remote_size += remote_size
+            errors.clear()
+            self.verbose_logger.warn(_('Some delta RPMs failed to download or rebuild. Retrying..'))
+        if callback_total and not errors:
+            callback_total(all_remote_pkgs, all_remote_size, beg_download)
+
+        if not downloadonly:
+            # XXX: Run unlocked?  Skip this for now..
+            self.plugins.run('postdownload', pkglist=pkglist, errors=errors)
 
         # Close curl object after we've downloaded everything.
         if hasattr(urlgrabber.grabber, 'reset_curl_obj'):
             urlgrabber.grabber.reset_curl_obj()
 
+        if downloadonly and not errors: # caller handles errors
+            self.verbose_logger.info(_('exiting because "Download Only" specified'))
+            sys.exit(self.exit_code)
         return errors
 
     def verifyHeader(self, fo, po, raiseError):
-        """check the header out via it's naevr, internally"""
+        """Check that the header of the given file object and matches
+        the given package.
+
+        :param fo: the file object to check
+        :param po: the package object to check
+        :param raiseError: if *raiseError* is True, a
+           :class:`URLGrabError` will be raised if the header matches
+           the package object, or cannot be read from the file.  If
+           *raiseError* is False, 0 will be returned in the above
+           cases
+        :return: 1 if the header matches the package object, and 0 if
+           they do not match, and *raiseError* is False
+        :raises: :class:`URLGrabError` if *raiseError* is True, and
+           the header does not match the package object or cannot be
+           read from the file
+        """
         if type(fo) is types.InstanceType:
             fo = fo.filename
             
@@ -2076,9 +2629,12 @@ class YumBase(depsolve.Depsolve):
         return 1
         
     def downloadHeader(self, po):
-        """download a header from a package object.
-           output based on callback, raise yum.Errors.YumBaseError on problems"""
+        """Download a header from a package object.
 
+        :param po: the package object to download the header from
+        :raises: :class:`yum.Errors.RepoError` if there are errors
+           obtaining the header
+        """
         if hasattr(po, 'pkgtype') and po.pkgtype == 'local':
             return
                 
@@ -2097,8 +2653,8 @@ class YumBase(depsolve.Depsolve):
                 return
         else:
             if self.conf.cache:
-                raise Errors.RepoError, \
-                _('Header not in local cache and caching-only mode enabled. Cannot download %s') % po.hdrpath
+                raise Errors.RepoError(_('Header not in local cache and caching-only mode enabled. Cannot download %s') % po.hdrpath,
+                                       repo=repo)
         
         if self.dsCallback: self.dsCallback.downloadHeader(po.name)
         
@@ -2122,15 +2678,17 @@ class YumBase(depsolve.Depsolve):
             return
 
     def sigCheckPkg(self, po):
-        '''
-        Take a package object and attempt to verify GPG signature if required
+        """Verify the GPG signature of the given package object.
 
-        Returns (result, error_string) where result is:
-            - 0 - GPG signature verifies ok or verification is not required.
-            - 1 - GPG verification failed but installation of the right GPG key
-                  might help.
-            - 2 - Fatal GPG verification error, give up.
-        '''
+        :param po: the package object to verify the signature of
+        :return: (result, error_string) 
+           where result is::
+
+              0 = GPG signature verifies ok or verification is not required.
+              1 = GPG verification failed but installation of the right GPG key
+                    might help.
+              2 = Fatal GPG verification error, give up.
+        """
         if self._override_sigchecks:
             check = False
             hasgpgkey = 0
@@ -2181,6 +2739,9 @@ class YumBase(depsolve.Depsolve):
         return result, msg
 
     def cleanUsedHeadersPackages(self):
+        """Delete the header and package files used in the
+        transaction from the yum cache.
+        """
         filelist = []
         for txmbr in self.tsInfo:
             if txmbr.po.state not in TS_INSTALL_STATES:
@@ -2189,6 +2750,8 @@ class YumBase(depsolve.Depsolve):
                 continue
             if txmbr.po.repoid not in self.repos.repos:
                 continue
+            if txmbr.po.repo.keepcache:
+                continue
             
             # make sure it's not a local file
             repo = self.repos.repos[txmbr.po.repoid]
@@ -2218,27 +2781,42 @@ class YumBase(depsolve.Depsolve):
                     _('%s removed'), fn)
         
     def cleanHeaders(self):
+        """Delete the header files from the yum cache."""
+
         exts = ['hdr']
         return self._cleanFiles(exts, 'hdrdir', 'header')
 
     def cleanPackages(self):
+        """Delete the package files from the yum cache."""
+
         exts = ['rpm']
         return self._cleanFiles(exts, 'pkgdir', 'package')
 
     def cleanSqlite(self):
-        exts = ['sqlite', 'sqlite.bz2', 'sqlite-journal']
+        """Delete the sqlite files from the yum cache."""
+
+        exts = ['sqlite', 'sqlite.bz2', 'sqlite.gz', 'sqlite.xz',
+                'sqlite-journal']
         return self._cleanFiles(exts, 'cachedir', 'sqlite')
 
     def cleanMetadata(self):
-        exts = ['xml.gz', 'xml', 'cachecookie', 'mirrorlist.txt', 'asc']
+        """Delete the metadata files from the yum cache."""
+
+        exts = ['xml.gz', 'xml', 'cachecookie', 'mirrorlist.txt', 'asc',
+                'xml.bz2', 'xml.xz']
         # Metalink is also here, but is a *.xml file
         return self._cleanFiles(exts, 'cachedir', 'metadata') 
 
     def cleanExpireCache(self):
+        """Delete the local data saying when the metadata and mirror
+           lists were downloaded for each repository."""
+
         exts = ['cachecookie', 'mirrorlist.txt']
         return self._cleanFiles(exts, 'cachedir', 'metadata')
 
     def cleanRpmDB(self):
+        """Delete any cached data from the local rpmdb."""
+
         cachedir = self.conf.persistdir + "/rpmdb-indexes/"
         if not os.path.exists(cachedir):
             filelist = []
@@ -2271,9 +2849,31 @@ class YumBase(depsolve.Depsolve):
         return 0, [msg]
 
     def doPackageLists(self, pkgnarrow='all', patterns=None, showdups=None,
-                       ignore_case=False):
-        """generates lists of packages, un-reduced, based on pkgnarrow option"""
-
+                       ignore_case=False, repoid=None):
+        """Return a :class:`yum.misc.GenericHolder` containing
+        lists of package objects.  The contents of the lists are
+        specified in various ways by the arguments.
+
+        :param pkgnarrow: a string specifying which types of packages
+           lists to produces, such as updates, installed, available,
+           etc.
+        :param patterns: a list of names or wildcards specifying
+           packages to list
+        :param showdups: whether to include duplicate packages in the
+           lists
+        :param ignore_case: whether to ignore case when searching by
+           package names
+        :param repoid: repoid that all pkgs will belong to
+        :return: a :class:`yum.misc.GenericHolder` instance with the
+           following lists defined::
+
+             available = list of packageObjects
+             installed = list of packageObjects
+             updates = tuples of packageObjects (updating, installed)
+             extras = list of packageObjects
+             obsoletes = tuples of packageObjects (obsoleting, installed)
+             recent = list of packageObjects
+        """
         if showdups is None:
             showdups = self.conf.showdupesfromrepos
         ygh = misc.GenericHolder(iter=pkgnarrow)
@@ -2295,6 +2895,8 @@ class YumBase(depsolve.Depsolve):
             ndinst = {} # Newest versions by name.arch
             for po in self.rpmdb.returnPackages(patterns=patterns,
                                                 ignore_case=ic):
+                if not misc.filter_pkgs_repoid([po], repoid):
+                    continue
                 dinst[po.pkgtup] = po
                 if showdups:
                     continue
@@ -2304,8 +2906,13 @@ class YumBase(depsolve.Depsolve):
             installed = dinst.values()
                         
             if showdups:
-                avail = self.pkgSack.returnPackages(patterns=patterns,
+                avail = self.pkgSack.returnPackages(repoid=repoid,
+                                                    patterns=patterns,
                                                     ignore_case=ic)
+            elif repoid:
+                avail = self.pkgSack.sacks[repoid]
+                avail = avail.returnNewestByNameArch(patterns=patterns,
+                                                     ignore_case=ic)
             else:
                 try:
                     avail = self.pkgSack.returnNewestByNameArch(patterns=patterns,
@@ -2323,16 +2930,31 @@ class YumBase(depsolve.Depsolve):
                     key = (pkg.name, pkg.arch)
                     if pkg.pkgtup in dinst:
                         reinstall_available.append(pkg)
-                    elif key not in ndinst or pkg.verGT(ndinst[key]):
-                        available.append(pkg)
                     else:
-                        old_available.append(pkg)
+                        # if (self.allowedMultipleInstalls(pkg) or
+                        #     key not in ndinst):
+                        #  Might be because pattern specified a version, so
+                        # we need to do a search for name/arch to find any
+                        # installed. Alas. calling allowedMultipleInstalls()
+                        # is much slower than calling searchNevra(). *Sigh*
+                        ipkgs = self.rpmdb.searchNevra(pkg.name,
+                                                       arch=pkg.arch)
+                        ipkgs = misc.filter_pkgs_repoid(ipkgs, repoid)
+                        if ipkgs:
+                            ndinst[key] = sorted(ipkgs)[-1]
+
+                        if key not in ndinst or pkg.verGT(ndinst[key]):
+                            available.append(pkg)
+                        else:
+                            old_available.append(pkg)
 
         # produce the updates list of tuples
         elif pkgnarrow == 'updates':
             for (n,a,e,v,r) in self.up.getUpdatesList():
                 matches = self.pkgSack.searchNevra(name=n, arch=a, epoch=e, 
                                                    ver=v, rel=r)
+                # This is kind of wrong, depending on how you look at it.
+                matches = misc.filter_pkgs_repoid(matches, repoid)
                 if len(matches) > 1:
                     updates.append(matches[0])
                     self.verbose_logger.log(logginglevels.DEBUG_1,
@@ -2352,13 +2974,19 @@ class YumBase(depsolve.Depsolve):
         elif pkgnarrow == 'installed':
             installed = self.rpmdb.returnPackages(patterns=patterns,
                                                   ignore_case=ic)
+            installed = misc.filter_pkgs_repoid(installed, repoid)
         
         # available in a repository
         elif pkgnarrow == 'available':
 
             if showdups:
                 avail = self.pkgSack.returnPackages(patterns=patterns,
-                                                    ignore_case=ic)
+                                                    ignore_case=ic,
+                                                    repoid=repoid)
+            elif repoid:
+                avail = self.pkgSack.sacks[repoid]
+                avail = avail.returnNewestByNameArch(patterns=patterns,
+                                                     ignore_case=ic)
             else:
                 try:
                     avail = self.pkgSack.returnNewestByNameArch(patterns=patterns,
@@ -2392,9 +3020,21 @@ class YumBase(depsolve.Depsolve):
             avail = set(avail)
             for po in self.rpmdb.returnPackages(patterns=patterns,
                                                 ignore_case=ic):
+                if not misc.filter_pkgs_repoid([po], repoid):
+                    continue
                 if po.pkgtup not in avail:
                     extras.append(po)
 
+        # not in a repo but installed
+        elif pkgnarrow == 'distro-extras':
+            for po in self.rpmdb.returnPackages(patterns=patterns,
+                                                ignore_case=ic):
+                if not misc.filter_pkgs_repoid([po], repoid):
+                    continue
+                if self.pkgSack.searchNames([po.name]):
+                    continue
+                extras.append(po)
+
         # obsoleting packages (and what they obsolete)
         elif pkgnarrow == 'obsoletes':
             self.conf.obsoletes = 1
@@ -2402,6 +3042,7 @@ class YumBase(depsolve.Depsolve):
             for (pkgtup, instTup) in self.up.getObsoletesTuples():
                 (n,a,e,v,r) = pkgtup
                 pkgs = self.pkgSack.searchNevra(name=n, arch=a, ver=v, rel=r, epoch=e)
+                pkgs = misc.filter_pkgs_repoid(pkgs, repoid)
                 instpo = self.getInstalledPackageObject(instTup)
                 for po in pkgs:
                     obsoletes.append(po)
@@ -2433,7 +3074,12 @@ class YumBase(depsolve.Depsolve):
             recentlimit = now-(self.conf.recent*86400)
             if showdups:
                 avail = self.pkgSack.returnPackages(patterns=patterns,
-                                                    ignore_case=ic)
+                                                    ignore_case=ic,
+                                                    repoid=repoid)
+            elif repoid:
+                avail = self.pkgSack.sacks[repoid]
+                avail = avail.returnNewestByNameArch(patterns=patterns,
+                                                     ignore_case=ic)
             else:
                 try:
                     avail = self.pkgSack.returnNewestByNameArch(patterns=patterns,
@@ -2461,14 +3107,13 @@ class YumBase(depsolve.Depsolve):
 
         
     def findDeps(self, pkgs):
-        """
-        Return the dependencies for a given package object list, as well
-        possible solutions for those dependencies.
+        """Return the dependencies for a given package object list, as well
+        as possible solutions for those dependencies.
            
-        Returns the deps as a dict of dicts::
-            packageobject = [reqs] = [list of satisfying pkgs]
+        :param pkgs: a list of package objects
+        :return: the dependencies as a dictionary of dictionaries:
+           packageobject = [reqs] = [list of satisfying pkgs]
         """
-        
         results = {}
 
         for pkg in pkgs:
@@ -2495,10 +3140,22 @@ class YumBase(depsolve.Depsolve):
     # pre 3.2.10 API used to always showdups, so that's the default atm.
     def searchGenerator(self, fields, criteria, showdups=True, keys=False, 
                                              searchtags=True, searchrpmdb=True):
-        """Generator method to lighten memory load for some searches.
-           This is the preferred search function to use. Setting keys to True
-           will use the search keys that matched in the sorting, and return
-           the search keys in the results. """
+        """Yield the packages that match the given search criteria.
+        This generator method will lighten memory load for some
+        searches, and is the preferred search function to use.
+
+        :param fields: the fields to search
+        :param criteria: a list of strings specifying the criteria to
+           search for
+        :param showdups: whether to yield duplicate packages from
+           different repositories
+        :param keys: setting *keys* to True will use the search keys
+           that matched in the sorting, and return the search keys in
+           the results
+        :param searchtags: whether to search the package tags
+        :param searchrpmdb: whether to search the rmpdb
+           
+        """
         sql_fields = []
         for f in fields:
             sql_fields.append(RPM_TO_SQLITE.get(f, f))
@@ -2614,7 +3271,7 @@ class YumBase(depsolve.Depsolve):
         # ...but without showdups we want to output _just_ #3, which requires
         # we find the newest EVR po for the best "matching value". Without keys
         # it's the same, except we just want the newest EVR.
-        #  If we screw it up it's probably not even noticable most of the time
+        #  If we screw it up it's probably not even noticeable most of the time
         # either, so it's pretty thankless. HTH. HAND.
         # By default just sort using package sorting
         sort_func = operator.itemgetter(0)
@@ -2661,6 +3318,14 @@ class YumBase(depsolve.Depsolve):
                     yield (po, vs)
 
     def searchPackageTags(self, criteria):
+        """Search for and return a list packages that have tags
+        matching the given criteria.
+
+        :param criteria: a list of strings specifying the criteria to
+           search for
+        :return: a list of package objects that have tags matching the
+           given criteria
+        """
         results = {} # name = [(criteria, taglist)]
         for c in criteria:
             c = c.lower()
@@ -2677,11 +3342,16 @@ class YumBase(depsolve.Depsolve):
         return results
         
     def searchPackages(self, fields, criteria, callback=None):
-        """Search specified fields for matches to criteria
-           optional callback specified to print out results
-           as you go. Callback is a simple function of:
-           callback(po, matched values list). It will 
-           just return a dict of dict[po]=matched values list"""
+        """Deprecated.  Search the specified fields for packages that
+        match the given criteria, and return a list of the results.
+
+        :param fields: the fields to search
+        :param criteria: a list of strings specifying the criteria to
+           search for
+        :param callback: a function to print out the results as they
+           are found.  *callback* should have the form callback(po,
+           matched values list)
+        """
         warnings.warn(_('searchPackages() will go away in a future version of Yum.\
                       Use searchGenerator() instead. \n'),
                 Errors.YumFutureDeprecationWarning, stacklevel=2)           
@@ -2700,13 +3370,23 @@ class YumBase(depsolve.Depsolve):
     
     def searchPackageProvides(self, args, callback=None,
                               callback_has_matchfor=False):
+        """Search for and return a list package objects that provide
+        the given files or features.
+
+        :param args: a list of strings specifying the files and
+           features to search for the packages that provide
+        :param callback: a callback function to print out the results
+           as they are found
+        :param callback_has_matchfor: whether the callback function
+           will accept a list of strings to highlight in its output.
+           If this is true, *args* will be passed to *callback* so
+           that the files or features that were searched for can be
+           highlighted
+        """
         def _arg_data(arg):
             if not misc.re_glob(arg):
                 isglob = False
-                if arg[0] != '/':
-                    canBeFile = False
-                else:
-                    canBeFile = True
+                canBeFile = arg.startswith('/')
             else:
                 isglob = True
                 canBeFile = misc.re_filename(arg)
